require 'tk'

#
# #########################################################
#
# For displaying error messages.
#
require 'Win32API'

#
# Button styles:
#
$MB_OK = 0
$MB_OKCANCEL = 1
$MB_ABORTRETRYIGNORE = 2
$MB_YESNOCANCEL = 3
$MB_YESNO = 4
$MB_RETRYCANCEL = 5

#
# Icon styles:
#
$MB_ICONHAND = 16
$MB_ICONQUESTION = 32
$MB_ICONEXCLAMATION = 48
$MB_ICONASTERISK = 64

#
# Default button:
#
$MB_DEFBUTTON1 = 0
$MB_DEFBUTTON2 = 256
$MB_DEFBUTTON3 = 512

#
# Return values:
#
$IDOK = 1
$IDCANCEL = 2
$IDABORT = 3
$IDRETRY = 4
$IDIGNORE = 5
$IDYES = 6
$IDNO = 7

def messageBox(message, title = 'Message', style = 0)
	mb = Win32API.new("user32", "MessageBox", ['L', 'P', 'P', 'L'], 'L')
	return mb.Call(0, message, title, style)
end

#
# #########################################################
#
# Window drawing section.
#

font_name = "arial 10"

root = TkRoot.new() { title "ADD BOX VER 2" }
root.geometry('+195+200')

boxes_frame = TkFrame.new(root).pack(:side=>:top, :fill=>:x)

#
# The box list from the XML file:
#
box_list_frame = TkFrame.new(boxes_frame, :borderwidth=>3, :relief=>:ridge).pack(:anchor=>"n", :side=>:left, :padx=>10, :pady=>10)

box_list_label = TkLabel.new(box_list_frame, :relief=>:sunken, :background=>"lightgrey", :text=>"Box List", "font"=>font_name).pack(:fill=>:x)

box_list_bar_vertical = TkScrollbar.new(box_list_frame).pack(:side=>"right", :fill=>"y")

box_list = TkListbox.new(box_list_frame, "background"=>"white", "exportselection" => 0, "width"=>15, "height"=>15, :selectmode=>"browse", "font"=>font_name).pack("side"=>"left")

box_list.yscrollbar(box_list_bar_vertical)


first_box_frame = TkFrame.new(boxes_frame, :borderwidth=>3, :relief=>:ridge).pack(:anchor=>"n", :side=>:left, :padx=>10, :pady=>10)

first_button = TkButton.new(first_box_frame, :text=>"First Box", :background=>"lightgrey", :foreground=>"blue", "font"=>font_name).pack(:pady=>5)

first_list_frame = TkFrame.new(first_box_frame).pack("side"=>"top")
first_box_bar_vert = TkScrollbar.new(first_list_frame).pack("side"=>"right", "fill"=>"y")

first_box_list = TkListbox.new(first_list_frame, "background"=>"white", "exportselection" => 0, "width"=>10, "height"=>6, :selectmode=>"browse", "font"=>font_name).pack("side"=>"left")

first_box_list.yscrollbar(first_box_bar_vert)

clear_first_sel_button = TkButton.new(first_box_frame, :width=>12, :text=>"Clear Selection", :background=>"lightgrey", :foreground=>"blue", "font"=>font_name).pack(:pady=>5, :padx=>2)

del_first_sel_button = TkButton.new(first_box_frame, :width=>12, :text=>"Delete Selection", :background=>"lightgrey", :foreground=>"blue", "font"=>font_name).pack(:pady=>5, :padx=>2)

del_first_list_button = TkButton.new(first_box_frame, :width=>12, :text=>"Delete List", :background=>"lightgrey", :foreground=>"blue", "font"=>font_name).pack(:pady=>5, :padx=>2)


last_box_frame = TkFrame.new(boxes_frame, :borderwidth=>3, :relief=>:ridge).pack(:anchor=>"n", :side=>:left, :padx=>10, :pady=>10)

last_button = TkButton.new(last_box_frame, :text=>"Last Box", :background=>"lightgrey", :foreground=>"blue", "font"=>font_name).pack(:pady=>5)

last_list_frame = TkFrame.new(last_box_frame).pack("side"=>"top")
last_box_bar_vert = TkScrollbar.new(last_list_frame).pack("side"=>"right", "fill"=>"y")

last_box_list = TkListbox.new(last_list_frame, "background"=>"white", "exportselection" => 0, "width"=>10, "height"=>6, :selectmode=>"browse", "font"=>font_name).pack("side"=>"left")

last_box_list.yscrollbar(last_box_bar_vert)

clear_last_sel_button = TkButton.new(last_box_frame, :width=>12, :text=>"Clear Selection", :background=>"lightgrey", :foreground=>"blue", "font"=>font_name).pack(:pady=>5, :padx=>2)

del_last_sel_button = TkButton.new(last_box_frame, :width=>12, :text=>"Delete Selection", :background=>"lightgrey", :foreground=>"blue", "font"=>font_name).pack(:pady=>5, :padx=>2)

del_last_list_button = TkButton.new(last_box_frame, :width=>12, :text=>"Delete List", :background=>"lightgrey", :foreground=>"blue", "font"=>font_name).pack(:pady=>5, :padx=>2)


excl_box_frame = TkFrame.new(boxes_frame, :borderwidth=>3, :relief=>:ridge).pack(:anchor=>"n", :side=>:left, :padx=>10, :pady=>10)

excl_button = TkButton.new(excl_box_frame, :text=>"Exclusion Boxes", :background=>"lightgrey", :foreground=>"blue", "font"=>font_name).pack(:pady=>5)

excl_list_frame = TkFrame.new(excl_box_frame).pack("side"=>"top")
excl_box_bar_vert = TkScrollbar.new(excl_list_frame).pack("side"=>"right", "fill"=>"y")

excl_box_list = TkListbox.new(excl_list_frame, "background"=>"white", "exportselection" => 0, "width"=>10, "height"=>6, :selectmode=>"browse", "font"=>font_name).pack("side"=>"left")

excl_box_list.yscrollbar(excl_box_bar_vert)

clear_excl_sel_button = TkButton.new(excl_box_frame, :width=>12, :text=>"Clear Selection", :background=>"lightgrey", :foreground=>"blue", "font"=>font_name).pack(:pady=>5, :padx=>2)

del_excl_sel_button = TkButton.new(excl_box_frame, :width=>12, :text=>"Delete Selection", :background=>"lightgrey", :foreground=>"blue", "font"=>font_name).pack(:pady=>5, :padx=>2)

del_excl_list_button = TkButton.new(excl_box_frame, :width=>12, :text=>"Delete List", :background=>"lightgrey", :foreground=>"blue", "font"=>font_name).pack(:pady=>5, :padx=>2)


format_frame = TkFrame.new(boxes_frame, :borderwidth=>3, :relief=>:ridge).pack("anchor"=>"n", "side"=>"left", :pady=>10, :padx=>10, :fill=>:x)

format_label = TkLabel.new(format_frame, :text=>"Format Strings", :relief=>:sunken, :background=>"lightgrey", "font"=>font_name).pack(:fill=>:x)
format_label.pack()

format_list = TkListbox.new(format_frame, "background"=>"white", "exportselection" => 0, "height"=>4, "font"=>font_name).pack("side"=>"left", :fill=>:x)

format_list.insert("end", "$CUR")
format_list.insert("end", "'%0.0f'")
format_list.insert("end", "'%0.2f'")
format_list.insert("end", "NONE")

#These set the default format_list selections at startup. The indices start at 0, which is the default - no need to activate it.
#~ format_list.activate(1)
#~ format_list.activate(2)

format_list.selection_set(0)	# Highlight first one.
#~ format_list.selection_set(1)
#~ format_list.selection_set(2)

button_frame = TkFrame.new(root).pack(:side=>:top, :fill=>:x, :padx=>10, :pady=>5)

add_button = TkButton.new(button_frame, :width=>12, :background=>"lightgrey", :text=>"Add Boxes", :foreground=>"blue", "font"=>font_name).pack(:side=>:left, :anchor=>:s)

print_button = TkButton.new(button_frame, :width=>12, :background=>"lightgrey", :text=>"Print ON", :foreground=>"blue", "font"=>font_name).pack(:side=>:left, :padx=>10, :anchor=>:s)

clear_all_button = TkButton.new(button_frame, :width=>12, :text=>"Clear All", :foreground=>"blue", :background=>"lightgrey", "font"=>font_name).pack(:side=>:left, :anchor=>:s)

dest_frame = TkFrame.new(button_frame, :borderwidth=>3, :relief=>:ridge).pack(:side=>:left, :padx=>10)

dest_button = TkButton.new(dest_frame, :width=>8, :text=>"Dest Box", :background=>"lightgrey", :foreground=>"blue", "font"=>font_name).pack(:pady=>5)

dest_text = TkVariable.new
dest_entry = TkEntry.new(dest_frame, :textvariable=>dest_text, "font"=>font_name, :width=>12).pack()

output_frame = TkFrame.new(root, :borderwidth=>3, :relief=>:ridge).pack(:side=>:top, :fill=>:x, :padx=>10)

output_label = TkLabel.new(output_frame, :text=>"Add Box Output Zone: ' Ctrl-/ ' selects all text.", :relief=>:sunken, :background=>"lightgrey", "font"=>font_name, :borderwidth=>3).pack(:side=>:top, :fill=>:x)
out_text_bar_vert = TkScrollbar.new(output_frame).pack(:side=>:right, :fill=>:y)
out_text = TkText.new(output_frame, :height=>12, "font"=>font_name).pack(:side=>:bottom, :fill=>:x, :expand=>true)
out_text.yscrollbar(out_text_bar_vert)

bottom_frame = TkFrame.new(root).pack(:side=>:top, :fill=>:x, :pady=>5)

#
# ###############################################################
#
# Classes:
#

#
# Holds the information pertaining to a box: The actual box number; the top, bottom,
# left, and right coordinates; the box type [justification], the page number for the box.
#
class Box

	def initialize(top, bottom, left, right, box, type, page)
		@top = top.to_f
		@bottom = bottom.to_f
		@left = left.to_f
		@right = right.to_f
		@num = box
		@type = type
		@page = page.to_i
	end

	attr_reader :top, :bottom, :left, :right, :num, :type, :page
	attr_writer :top, :bottom, :left, :right, :num, :type, :page
end

#
# Holds the information pertaining to a Page: The page number; the first and last index for the
# page in the form_box_array.
#
class Page

	def initialize(num, first, last)
		@num = num
		@first = first
		@last = last
	end

	attr_reader :num, :first, :last
	attr_writer :num, :first, :last
end

#
# Holds the information pertaining to a range that will be added.
#
class Range

	def initialize(first_index, last_index, first_box, last_box, type, dir, top, bottom, left, right)
		@first_index = first_index
		@last_index = last_index
		@first_box = first_box
		@last_box = last_box
		@type = type
		@dir = dir
		@top = top
		@bottom = bottom
		@left = left
		@right = right
	end

	attr_reader :first_index, :last_index, :first_box, :last_box, :type, :dir, :top, :bottom, :left, :right
	attr_writer :first_index, :last_index, :first_box, :last_box, :type, :dir, :top, :bottom, :left, :right
end

#
# ###############################################################
#
# Globals:
#
cur_dir = "C:/temp/"

#
# Holds Box objects for the entire form.
#
box_obj_array = Array.new

#
# Holds Box numbers for the entire form.
#
box_list_array = Array.new

#
# Holds Page objects for each page in the form.
#
page_array = Array.new

#
# Holds Range objects for each addition event.
#
range_array = Array.new

#
# ###############################################################
#
# Methods:
#
def process_errors(error, var)

	err_msg = [
	"  ERROR - You need the same number of 'First' and 'Last' boxes.\n",
	"  ERROR - Incorrect Range: #{var}\t\n\nEach box needs to be on the same page.\n",
	"  ERROR - Incorrect Box Types: #{var}\t\n\nEach box needs to be Left/Center/Right/Decimal/Decimal No Point.\n",
	"  ERROR - Incorrect Direction: #{var}\t\n\nA COL add requires the First box to be above the Last box.\n",
	"  ERROR - Incorrect Direction: #{var}\t\n\nA ROW add requires the First box to be left of the Last box.\n",
	"  ERROR - Incorrect Range: #{var}\t\n\nThe First and Last boxes cannot be the same.\n",
	"  ERROR - Duplicate Box: #{var}\t\n\nThis box is already in the list.\n",
	"  ERROR - Duplicate Box: #{var}\t\n\nThis box is already in the First Box list.\n",
	"  ERROR - Duplicate Box: #{var}\t\n\nThis box is already in the Last Box list.\n",
	"  ERROR - Duplicate Box: #{var}\t\n\nThis box is already in the Exclusion Box list.\n"
	]

	#
	# Using bitwise operations, error is set on a bit by bit basis, where each bit represents an error message.
	#
	if (error > 0)

		mask = 1

		#
		# Math.frexp(error) returns a two element array containing the normalized fraction (a Float) and exponent
		# (a Fixnum) of error. In our case, the fraction is 0.5 and the exponent is a power of 2, as our error is 1 x 2
		# raised to 0,1,2,3,... So this returns 0.5 x 2[a power]. So, say error = 4, which is 1 x 2[2], which is the 3rd
		# error in our list. .frexp returns [0.5, 3] - we want the 3 [3rd error], we use 3 - 1 since we are starting
		# from 0 not 1. Just doing this so that I do not have to keep updating the 0.upto( ) each time I add a new error.
		#
		0.upto(Math.frexp(error)[1]-1) do |shift|
			if (((mask << shift) & error) > 0)
				messageBox(err_msg[shift], "Error!", $MB_ICONEXCLAMATION|$MB_OK)
			end
		end
	end
end

def get_file_name(dir, type)

	ftypes = case (type)
			when ("XML"): [ ["XML files", '.xml'] ]
		end

	Tk.getOpenFile(:filetypes=>ftypes, :initialdir=>dir)
end

#
# This builds an array of Box objects. Each Box object holds information for all text boxes
# [boxes other than 1D or 2D barcode boxes] from a supplied file name. The box number,
# screen coordinates and justification info is stored in each object.
#
def build_box_array(file)

	tmp_array = Array.new
	box = String.new
	type = String.new
	is_text = false

	File.open(file, "r") do |src_file|

		while (line = src_file.gets)

			if (line =~ /^<page ref=\"pg(\d+)\"/)

				page = $1
			end

			if (line =~ /^<text ref=\"(box\d+_\d+)\" justification=\"(left|center|right|decimal|decimal_no_point)\"/)

				#
				# We have a non barcode box, grab the box number and the justification.
				# is_text makes sure we do not grab the coordinate info for a barcode box.
				#
				is_text = true
				box = $1
				type = $2
			end

			#
			# Now look for the associated coordinates.
			#
			if (line =~ /^(<bbox left=\")(\d+\.\d+)(\" top=\")(\d+\.\d+)(\" right=\")(\d+\.\d+)(\" bottom=\")(\d+\.\d+)(\"\/>)$/)
				if (is_text)
					#
					# The way the XML files are constructed, we know that once we have the box
					# coordinate info, we already have the box number and justification info.
					#
					tmp_array.push(Box.new($4, $8, $2, $6, box, type, page))
					is_text = false
				end
			end
		end
	end

	tmp_array
end

#
# ###########################################################
#
# Menu:
#
#		Read:
#			Read Ruby Code file to create form box list [displaying box numbers].
#			Read XML file for box numbers [form box list] AND box truncation widths.
#
#		Profile:
#			Selection of DataFlow Profile - Individual/Entity/Fiduciary/Preparer
#
#		Exit:
#			Exit the DataFlow Code Retriever Application.
#
main_menu = TkMenu.new(root)

read_menu = TkMenu.new(main_menu, :tearoff=>false)

#
# This reads the .XML file and builds an array of Box objects, setting each object
# to the box number and the width in chars that each box can hold. If the width cannot be
# determined because the font type is not correct, we insert "MAN" for the width.'
#
# The main purpose of reading the XML file is for dataflow truncation.
#
# The form_box_list is then poulated with the box numbers.
#
read_menu.add('command', :label=> "XML File", :command=> proc {

	tmp_array = Array.new

	fname = get_file_name(cur_dir, "XML")

	if (!fname.empty?)

		cur_dir = File.dirname(fname)
		form_name = fname

		box_list_label.configure("text", "#{File.basename(form_name, ".*").upcase} Box List")
		box_list.delete(0, "end")

		box_obj_array = build_box_array(fname)

		#
		# Build the page_array which holds each page number on the form with the associated
		# first and last index into the box_obj_array.
		#
		page_array.clear
		first = page = 0

		box_obj_array.each_index do |i|

			if (box_obj_array[i].page != page)

				if (page > 0)
					last = i - 1
					page_array.push(Page.new(page, first, last))
				end

				first = i
				page = box_obj_array[i].page
			end

			#
			# Grab the page and box number and insert into tmp_array so we can build a sorted list of boxes.
			#
			box_obj_array[i].num.scan(/box(\d+)_(\d+)/) { tmp_array.push([$1.to_i,$2.to_i]) }
		end

		#
		# We need to set the last index of the very last page number and insert that page's info into page_array.
		#
		page_array.push(Page.new(page, first, box_obj_array.length - 1))

		#
		# Now sort the tmp_array and insert into the box_list [TK land].
		#
		tmp_array.sort!
		tmp_array.each_index { |i|
			box_list.insert("end", "box#{tmp_array[i][0]}_#{tmp_array[i][1]}")
		}
	end
})

main_menu.add('cascade', :menu=>read_menu, :label=>"Read")

main_menu.add('command', :label=> "Exit", :command=> proc{exit})

#
# Adding main_menu to the root window.
#
root.menu(main_menu)

#
# Button bindings:
#
first_button.bind("Button-1") {

	#
	# The selected box from the box_list will be inserted into the first_box_list at either the "end" of the list or
	# over a slected box in the list. Duplicate boxes will not be allowed in the list.
	#
	if (box_list.curselection.length > 0)

		box = box_list.get(box_list.curselection)
		sel = first_box_list.curselection

		case
			when (first_box_list.get(0, "end").include?(box))

				process_errors(64, box)

			when (last_box_list.get(0, "end").include?(box))

				process_errors(256, box)

			when (excl_box_list.get(0, "end").include?(box))

				process_errors(512, box)
			else
				if (sel.length > 0)

					#
					# This is an edit of a box in the list.
					#
					first_box_list.delete(sel)
					first_box_list.insert(sel, box)
				else
					first_box_list.insert("end", box)
				end
		end
	end
}

clear_first_sel_button.bind("Button-1") { first_box_list.selection_clear(0, "end") }

del_first_sel_button.bind("Button-1") {

	if (first_box_list.curselection.length > 0)

		first_box_list.delete(first_box_list.curselection)
	end
}

del_first_list_button.bind("Button-1") { first_box_list.delete(0, "end") }

last_button.bind("Button-1") {

	#
	# The selected box from the box_list will be inserted into the last_box_list at either the "end" of the list or
	# over a slected box in the list. Duplicate boxes will not be allowed in the list.
	#
	if (box_list.curselection.length > 0)

		box = box_list.get(box_list.curselection)
		sel = last_box_list.curselection

		case
			when (last_box_list.get(0, "end").include?(box))

				process_errors(64, box)

			when (first_box_list.get(0, "end").include?(box))

				process_errors(128, box)

			when (excl_box_list.get(0, "end").include?(box))

				process_errors(512, box)
			else
				if (sel.length > 0)

					#
					# This is an edit of a box in the list.
					#
					last_box_list.delete(sel)
					last_box_list.insert(sel, box)
				else
					last_box_list.insert("end", box)
				end
		end
	end
}

clear_last_sel_button.bind("Button-1") { last_box_list.selection_clear(0, "end") }

del_last_sel_button.bind("Button-1") {

	if (last_box_list.curselection.length > 0)

		last_box_list.delete(last_box_list.curselection)
	end
}

del_last_list_button.bind("Button-1") { last_box_list.delete(0, "end") }

excl_button.bind("Button-1") {

	#
	# The selected box from the box_list will be inserted into the excl_box_list at either the "end" of the list or
	# over a slected box in the list. Duplicate boxes will not be allowed in the list. You cannot select an exclusion
	# box if it is already in the first or last box lists.
	#
	if (box_list.curselection.length > 0)

		box = box_list.get(box_list.curselection)
		sel = excl_box_list.curselection

		case
			when (excl_box_list.get(0, "end").include?(box))

				process_errors(64, box)

			when (first_box_list.get(0, "end").include?(box))

				process_errors(128, box)

			when (last_box_list.get(0, "end").include?(box))

				process_errors(256, box)
			else
				if (sel.length > 0)

					#
					# This is an edit of a box in the list.
					#
					excl_box_list.delete(sel)
					excl_box_list.insert(sel, box)
				else
					excl_box_list.insert("end", box)
				end
		end
	end
}

clear_excl_sel_button.bind("Button-1") { excl_box_list.selection_clear(0, "end") }

del_excl_sel_button.bind("Button-1") {

	if (excl_box_list.curselection.length > 0)

		excl_box_list.delete(excl_box_list.curselection)
	end
}

del_excl_list_button.bind("Button-1") { excl_box_list.delete(0, "end") }

clear_all_button.bind("Button-1") {

	first_box_list.delete(0, "end")
	last_box_list.delete(0, "end")
	excl_box_list.delete(0, "end")
	dest_text.value = ''
}

dest_button.bind("Button-1") {

	dest_text.value = box_list.get(box_list.curselection) if (box_list.curselection.length > 0)
}

add_button.bind("Button-1") {

	# Clear the output area.
	out_text.delete("1.0", "end")

	first_page_num_array = Array.new
	last_page_num_array = Array.new
	excl_array = Array.new

	math_str = String.new
	format_str = String.new
	dir = String.new

	first_box_obj = Box.new(nil, nil, nil, nil, nil, nil, nil)
	last_box_obj = Box.new(nil, nil, nil, nil, nil, nil, nil)

	#
	# These arrays are the complete box numbers [i.e.'box1_10'] using for an easy way to get the whole box number.
	#
	first_box_array = first_box_list.get(0, "end")
	last_box_array = last_box_list.get(0, "end")

	#
	# Using these arrays as a quick way to grab just the page and box numbers from a box.
	#
	first_box_array.each do |box|

		first_page_num_array.push([$2.to_i,$4.to_i]) if (box =~ /(box)(\d+)(_)(\d+)/)
	end

	last_box_array.each do |box|

		last_page_num_array.push([$2.to_i,$4.to_i]) if (box =~ /(box)(\d+)(_)(\d+)/)
	end

	excl_array = excl_box_list.get(0, "end")

	first_index = last_index = page = top = bottom = left = right = error = 0

	if (first_box_array.length != last_box_array.length)
		process_errors(1, nil)
	else
		#
		# Now we build the range array checking that: each range [first box/last box pair] is on the same page,
		# both boxes in the range are of the same type and determining [each range] the direction [row/col] of
		# the addition, and making sure each range has the first box 'above' [column add] or to the 'left' of
		# [row add] the last box. Also, all of these arrays are the same size, so using the index of one to access 
		# the others.
		#
		range_array.clear

		first_box_array.each_index { |i|

			#
			# Check for a probably rare error where the first box is the same as the last box for a range:
			#
			if (first_box_array[i].eql?(last_box_array[i]))

				error = 32
				process_errors(error, "#{first_box_array[i]}..#{last_box_array[i]}")
				break
			end

			#
			# Making sure page nums are the same per range. If there is one range that has incorrect
			# page numbers we will break out of the whole addition. User must correct first.
			#
			if (first_page_num_array[i][0] != last_page_num_array[i][0])

				error = 2
				process_errors(error, "#{first_box_array[i]}..#{last_box_array[i]}")
				break
			else
				if (page != first_page_num_array[i][0])

					page = first_page_num_array[i][0]

					page_array.each_index do |j|

						if (page_array[j].num == page)

							first_index = page_array[j].first
							last_index = page_array[j].last
							break
						end
					end
				end
			end

			first_box_obj = last_box_obj = nil

			first_index.upto(last_index) do |j|

				case
					when (box_obj_array[j].num.eql?(first_box_array[i]))

						first_box_obj = box_obj_array[j]

					when (box_obj_array[j].num.eql?(last_box_array[i]))

						last_box_obj = box_obj_array[j]
				end

				break if (first_box_obj and last_box_obj)
			end

			#
			# Making sure both types are the same per range. If there is one range that fails this
			# check we will break out of the whole addition. User must correct first.
			#
			if (!first_box_obj.type.eql?(last_box_obj.type))

				error = 4
				process_errors(error, "#{first_box_array[i]}..#{last_box_array[i]}")
				break
			else

				#
				# Determine the direction: row or col add or we end up just adding the first and last boxes together.
				#
				case
					when ((first_box_obj.left == last_box_obj.left) and (first_box_obj.right == last_box_obj.right))

						dir = "COL"
						top = first_box_obj.top
						bottom = last_box_obj.bottom
						left = first_box_obj.left
						right = first_box_obj.right

						if (first_box_obj.top < last_box_obj.top)

							error = 8
							process_errors(error, "#{first_box_array[i]}..#{last_box_array[i]}")
							break
						end

					when ((first_box_obj.top == last_box_obj.top) and (first_box_obj.bottom == last_box_obj.bottom))

						dir = "ROW"
						top = first_box_obj.top
						bottom = first_box_obj.bottom
						left = first_box_obj.left
						right = last_box_obj.right

						if (first_box_obj.left > last_box_obj.left)

							error = 16
							process_errors(error, "#{first_box_array[i]}..#{last_box_array[i]}")
							break
						end
					else
						dir = nil
				end
			end

			#
			# If we got this far, we have a valid range to insert into the range_array. [using first_box.type, it MUST equal last_box.type anyways]
			#
			range_array.push(Range.new(first_index, last_index, first_box_obj.num, last_box_obj.num, first_box_obj.type, dir, top, bottom, left, right))
		}

		unless (error > 0)
			#
			# Now run through the range array, performing the range addition.
			#
			range_array.each do |range|

				range.first_index.upto(range.last_index) do |j|

					case (range.dir)

						when ("COL")

							if ((box_obj_array[j].left == range.left) and (box_obj_array[j].right == range.right))

								unless (box_obj_array[j].top > range.top)

									unless (box_obj_array[j].bottom < range.bottom)

										if (box_obj_array[j].type.eql?(range.type))

											unless (excl_array.include?(box_obj_array[j].num))
												math_str += "#{box_obj_array[j].num}.to_f + "
											end
										end
									end
								end
							end

						when ("ROW")

							if ((box_obj_array[j].top == range.top) and (box_obj_array[j].bottom == range.bottom))

								unless (box_obj_array[j].left < range.left)

									unless (box_obj_array[j].right > range.right)

										if (box_obj_array[j].type.eql?(range.type))

											unless (excl_array.include?(box_obj_array[j].num))
												math_str += "#{box_obj_array[j].num}.to_f + "
											end
										end
									end
								end
							end
						else
							#
							# Just adding the first and last range boxes togeher as long as the types are the same.
							#
							if (box_obj_array[j].type.eql?(range.type))
								math_str = "#{range.first_box}.to_f + #{range.last_box}.to_f"
								break
							end
					end
				end
			end

#~ range_array.each do |range|

	#~ out_text.insert("end", "First Index: #{range.first_index}  Last Index: #{range.last_index}  First Box: #{range.first_box}  Last Box: #{range.last_box}  Type: #{range.type}  Dir: #{range.dir}  Top: #{range.top}  Bot: #{range.bottom}  Left: #{range.left}  Right: #{range.right}\n\n")
#~ end

			format_str = case format_list.index("active")
						when 0 then " $CUR % "
						when 1 then " '%0.0f' % "
						when 2 then " '%0.2f' % "
						when 3 then ""
					end

			math_str = "#{dest_text.to_s} =#{format_str}(#{math_str =~ / \+ $/ ? math_str.chomp!(" + ") : math_str})\n"
			out_text.insert("end", math_str)

			if (print_button.cget("text") == "Print ON")
				out_text.insert("end", "print '#{dest_text.to_s}', #{dest_text.to_s}")
			end
		end
	end

	# Set the focus to the output text window, and put the cursor at the first char on line one.
	out_text.focus
	out_text.mark_set('insert', '1.0')
}

print_button.bind("Button-1") {

	#
	# User can toggle the associated Print line "ON/OFF".
	#
	case print_button.cget("text")

		when "Print OFF" then print_button.configure("text", "Print ON")
		when "Print ON" then print_button.configure("text", "Print OFF")
	end
	}

Tk.mainloop()
